package com.link.core.util;

import com.link.base.enterprise.model.CoreEnterprise;
import java.lang.reflect.Field;

public class ChiperUtil {
   private static final String ENCRYPT_FLAG = "0";
   private static final String DECRYPT_FLAG = "1";
   private static final String HANDLEFLAG = "(AES)";
   public static final String LNK_CHIPER_READ_KEY = "lnk_chiper_read";
   public static final String LNK_CHIPER_WRITE_KEY = "lnk_chiper_write";

   public static void setFieldValueByAesEncrypt(Object object, String targetfieldName) throws Exception {
      setFieldValueByAes(object, targetfieldName, "0", false, 0, 0);
   }

   public static void setFieldValueByAesDecrypt(Object object, String targetfieldName) throws Exception {
      setFieldValueByAes(object, targetfieldName, "1", false, 0, 0);
   }

   public static void setHidenFieldValueByAesDecrypt(Object object, String targetfieldName, String startIndex, String endIndex) throws Exception {
      setFieldValueByAes(object, targetfieldName, "1", true, Integer.valueOf(startIndex) - 1, Integer.valueOf(endIndex));
   }

   public static void setHidenFieldValue(Object object, String targetfieldName, String startIndex, String endIndex) throws Exception {
      setFieldValueByAes(object, targetfieldName, "-1", true, Integer.valueOf(startIndex) - 1, Integer.valueOf(endIndex));
   }

   private static void setFieldValueByAes(Object object, String targetfieldName, String flag, Boolean hideFlag, int startIndex, int endIndex) throws Exception {
      Class objClass = object.getClass();
      Field[] fields = objClass.getDeclaredFields();
      boolean isSucess = setValueByAes(object, fields, targetfieldName, flag, hideFlag, startIndex, endIndex);
      if (!isSucess) {
         Class superClass = objClass.getSuperclass();
         if (null != superClass) {
            Field[] superFields = superClass.getDeclaredFields();
            setValueByAes(object, superFields, targetfieldName, flag, hideFlag, startIndex, endIndex);
         }
      }

   }

   private static boolean setValueByAes(Object object, Field[] fields, String targetfieldName, String flag, Boolean hideFlag, int startIndex, int endIndex) throws Exception {
      Field[] var7 = fields;
      int var8 = fields.length;

      for(int var9 = 0; var9 < var8; ++var9) {
         Field field = var7[var9];
         String currentFieldName = field.getName();
         if (currentFieldName.equals(targetfieldName)) {
            field.setAccessible(true);
            String newValue = String.valueOf(field.get(object));
            if ("0".equals(flag) && !newValue.startsWith("(AES)")) {
               newValue = "(AES)" + AesUtil.encrypt(newValue);
            }

            if ("1".equals(flag) && newValue.startsWith("(AES)")) {
               newValue = AesUtil.decrypt(newValue.substring(5));
            }

            if (hideFlag && startIndex + 1 <= newValue.length() && newValue.indexOf("****") == -1) {
               StringBuilder str = new StringBuilder(newValue);
               newValue = str.replace(startIndex, endIndex, "****").toString();
            }

            field.set(object, newValue);
            return true;
         }
      }

      return false;
   }

   public static void main(String[] args) throws Exception {
      CoreEnterprise enterprise = new CoreEnterprise();
      enterprise.setName("张三,hello!!");
      System.out.println("加密前->" + enterprise.getName());
      setFieldValueByAesEncrypt(enterprise, "name");
      System.out.println("加密后->" + enterprise.getName());
      setHidenFieldValueByAesDecrypt(enterprise, "name", "1", "3");
      setHidenFieldValue(enterprise, "name", "1", "3");
      System.out.println("解密后->" + enterprise.getName());
      System.out.println(CoreEnterprise.class.getName());
   }
}
